// astroblahhh-music-player.js
//
//
// Except for parts not by Apollia:
//
//    Copyright (C) 2014  Apollia
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as
//    published by the Free Software Foundation, either version 3 of the
//    License, or (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see http://www.gnu.org/licenses/ .
//
//
//    Contact info:     http://astroblahhh.com/contact-apollia.shtml 



function Astroblahhh_Music_Player___Object()
{	
	
	var ABPlayer=this;
	
	this.app_name="Astroblahhh Basic MP3 Player in JavaScript";
	this.app_version="version 1";
	
	
	
	/* Things declared with var have local scope and are unavailable outside.  So, things outside of Astroblahhh_Music_Player___Object can't access "ABPlayer".
	
	(However, I declared a global variable "ABPlayer" outside this object so I could use it as a convenient abbreviation.  I declared a local "ABPlayer" variable so JavaScript wouldn't have to trawl through the global scope every time I mention "ABPlayer" to figure out what I mean.)
	
	Things declared with "this.[whatever]" are available to their parent scope.  So, things outside of Astroblahhh_Music_Player___Object can directly access app_name and app_version. */
	
		
	this.Run = function()
	{
		
		ABPlayer.Config=new ABPlayer.Config_Object();
		ABPlayer.Audio_Stream_Controller=new ABPlayer.Audio_Stream_Controller_Object();
		ABPlayer.Audio_Stream_Status=new ABPlayer.Audio_Stream_Status_Object();
		
		ABPlayer.Layout_Overlord=new ABPlayer.Layout_Overlord_Object();
		
		ABPlayer.Songbar_Overlord=new ABPlayer.Songbar_Overlord_Object();
		
		ABPlayer.Widget_Overlord = new ABPlayer.Widget_Overlord_Object();
		ABPlayer.Widget_Click_Overlord = new ABPlayer.Widget_Click_Overlord_Object();
		
		ABPlayer.Queue_Overlord = new ABPlayer.Queue_Overlord_Object();
		
		ABPlayer.Volume_Overlord=new ABPlayer.Volume_Overlord_Object();
		
		ABPlayer.Do_SoundManager_Setup();	
	}
	
	
	this.Do_SoundManager_Setup = function ()
	{
		var Config = ABPlayer.Config;
		
		soundManager.setup
		({
			url: 'soundmanager/swf/',
			flashVersion: 9,
			preferFlash: false,
			useHTML5Audio: true,
			
			defaultOptions: 
			{			
				volume: ABPlayer.Config.default_volume,
				
				onsuspend: function()
					{
						window.alert("on suspend");
						ABPlayer.Audio_Stream_Controller.Pause();
					},
				ontimeout: function()
					{	
						window.alert("on timeout");
						ABPlayer.Audio_Stream_Controller.Pause();
					},
				whileloading: function() 
					{
						var percentage = Math.round((this.bytesLoaded / this.bytesTotal) * 1000) / 10;
						
						ABPlayer.Audio_Stream_Status.Do_While_Loading
						(	
							{
								id: this.id,
								loaded: this.bytesLoaded,
								total: this.bytesTotal,
								percentage: percentage
							}
						);
					},
				whileplaying: function() 
					{
						var percentage = Math.round((this.position / this.duration) * 10000) / 100;
						
							ABPlayer.Audio_Stream_Status.Do_While_Playing(
							{
								id: this.id,
								position: this.position,
								duration: this.duration,
								percentage: percentage
							}
						)
					},
					
				onfinish: function()
					{
						ABPlayer.Songbar_Overlord.Empty_Out_Songbar();
						
						
						if ( ABPlayer.Queue_Overlord.Current_Queue.Action_When_End_Of_Song_Is_Reached == "Stop and Don't Go To Next Queued Track")
						{
							ABPlayer.Audio_Stream_Status.Draw_PlayPause_Button("Play");
							ABPlayer.Audio_Stream="Not Yet Started";
						}
						else if ( ABPlayer.Queue_Overlord.Current_Queue.Action_When_End_Of_Song_Is_Reached == "Go To Next Queued Track" )
						{
							
							ABPlayer.Audio_Stream_Controller.Wait_x_Milliseconds_Then_Start_Next_Track( ABPlayer.Queue_Overlord.Current_Queue.Milliseconds_To_Wait_Before_Starting_Next_Queue_Track
							);
						
						}
					},
					
				onstop: function()
					{
						ABPlayer.Songbar_Overlord.Empty_Out_Songbar();
					}
			}
		})
	
	}
}