// queue_overlord.js
//
//
// Except for parts not by Apollia:
//
//    Copyright (C) 2014  Apollia
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Affero General Public License as
//    published by the Free Software Foundation, either version 3 of the
//    License, or (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Affero General Public License for more details.
//
//    You should have received a copy of the GNU Affero General Public License
//    along with this program.  If not, see http://www.gnu.org/licenses/ .
//
//
//    Contact info:     http://astroblahhh.com/contact-apollia.shtml 




Astroblahhh_Music_Player___Object.prototype.Queue_Overlord_Object = function()
{
	var ABPlayer = window.Astroblahhh_Music_Player;
	
	// 16:46 07/09/2014.  It's possible to have multiple queues.
	// The Queue array holds them all.
	//
	// Each Queue holds a numbered array of Track objects.  Queue.Main_Queue.Tracks[0], 1, etc.
	
	
	this.Queue=new Array();
	
	this.Current_Queue="Not Yet Set";
		// Contains the current queue object, like Queue.Main_Queue.
	
	
	
	this.Provide_Queue_HTML = function ( settings )
	{
		var queue_name;
		var Queue;
		var output;
		var queue_arrin;
		var html_id_for_track;
		
		
		queue_name = settings.queue_name;
		
		Queue=ABPlayer.Queue_Overlord.Queue[queue_name];
		
		
		output="";
		
		queue_arrin=0;
		
		Queue.Tracks.forEach(
			
			function ( track )
			{	
			
				html_id_for_track = ABPlayer.Queue_Overlord.Make_HTML_ID_Name_for_Track(queue_name, queue_arrin);
				
				
				output = output.concat("<li><span class=\"track\" id=\"" + html_id_for_track + "\" ref=\"" + queue_arrin + "\">" + track.url + "</span></li>");
				
				queue_arrin++;

			}
			
		);
		
		return output;
		
		
	}
	
	
	this.Make_Displayable_Queue_Track_ID_String = function (queue_name, queue_arrin)
	{
		var result;
		
		result = queue_name + " " + queue_arrin;
		
		return result;
	}
	
	
	
	this.Make_HTML_ID_Name_for_Track = function (queue_name, queue_arrin)
	{
		var result;
		
		result = queue_name + "_Track_" + queue_arrin;
		
		return result;
	}



	this.Create_New_Queue = function(queue_name)
	{	
		this.Queue[queue_name]=
			{ 
				name: queue_name, 
				
				Tracks: [], 
				
				Action_When_End_Of_Queue_Is_Reached: 
					ABPlayer.Config.default_action_when_end_of_queue_is_reached,
				
				Action_When_End_Of_Song_Is_Reached:
					ABPlayer.Config.default_action_after_song_ends,
					
				Milliseconds_To_Wait_Before_Starting_Next_Queue_Track:
					ABPlayer.Config.default_milliseconds_to_wait_before_starting_next_queue_track,
				
				Position: 0
			};
			
	}
	
	
	
	this.Set_Position_in_Queue = function (queue_arrin)
	{

		this.Remove_Current_Track_Style();
		
		queue_arrin_integer=parseInt(queue_arrin);
			
		this.Current_Queue.Position = queue_arrin_integer;
		
		this.Add_Current_Track_Style();
		
	}
	
	
	
	this.Move_to_Prev_Track = function()
	{	
		var Current_Queue_Position;
		var Current_Queue_Length;
		var Prev_Track_Position;
		
		Current_Queue_Position = this.Current_Queue.Position;
		
		Current_Queue_Length = this.Current_Queue.Tracks.length;
		
		Prev_Track_Position=Current_Queue_Position-1;
		
		if (Prev_Track_Position < 0)
		{	
			ABPlayer.Queue_Overlord.Set_Position_in_Queue(Current_Queue_Length-1);
		
			return true;
		}
		
		ABPlayer.Queue_Overlord.Set_Position_in_Queue( Prev_Track_Position );
		
		return true;
	}
	
	
	
	this.Move_to_Next_Track = function()
	{	
		var Current_Queue_Position;
		var Current_Queue_Length;
		var Next_Track_Position;
		
		
		Current_Queue_Position = this.Current_Queue.Position;
		
		Current_Queue_Length = this.Current_Queue.Tracks.length;
		
		
		Next_Track_Position=Current_Queue_Position+1;
		
		if (Next_Track_Position >= Current_Queue_Length)
		{	
			if ( ABPlayer.Queue_Overlord.Current_Queue.Action_When_End_Of_Queue_Is_Reached == "Stop, and Go To First Track" )
			{	ABPlayer.Queue_Overlord.Set_Position_in_Queue( 0 );
			
				return false;
			}
			
			if ( ABPlayer.Queue_Overlord.Current_Queue.Action_When_End_Of_Queue_Is_Reached == "Stop, and Stay On The Last Track" )
			{	ABPlayer.Audio_Stream_Controller.Stop();
				return false;
			}
			else if ( ABPlayer.Queue_Overlord.Current_Queue.Action_When_End_Of_Queue_Is_Reached == "Repeat from Start" )
			{	
				ABPlayer.Queue_Overlord.Set_Position_in_Queue( 0 );
				return true;
			}
		}
		
		ABPlayer.Queue_Overlord.Set_Position_in_Queue( Next_Track_Position );
		
		return true;
	}
	
	
	
	this.Add_Current_Track_Style = function()
	{
		var Current_Queue=this.Current_Queue;
		
		html_id_for_track = ABPlayer.Queue_Overlord.Make_HTML_ID_Name_for_Track(Current_Queue.name, Current_Queue.Position);
		
		$("#" + html_id_for_track).addClass("current_track");
	}
	
	
	
	this.Remove_Current_Track_Style = function()
	{	
		
		var Current_Queue=this.Current_Queue;
		
		html_id_for_track = ABPlayer.Queue_Overlord.Make_HTML_ID_Name_for_Track(Current_Queue.name, Current_Queue.Position);
				
		$("#" + html_id_for_track).removeClass("current_track");
		
		
	}

	

	this.Add_Track_to_Queue = function(track)
	{
		
		this.Current_Queue.Tracks.push(track);
	}
	

	this.Set_Current_Queue_to_ = function(queue_name)
	{	
		this.Current_Queue=this.Queue[queue_name];
	}



}